%Models a Poisson Process from first principles
mu = 5.2;                               %rate, events/time period
timePeriods = 20000;                    %number of observations, for < 1% error
numEvents = mu*timePeriods;             %number of events

event = rand(1,numEvents)*timePeriods;  %continuous time
event1 = rand(1,numEvents)*timePeriods; %continuous time

figure; 
plot(event1,event,'.','color',[0.8 0.8 0]);
xlabel('Time (arbitrary units)'); ylabel('Far Away Light Source')
%yyaxis right; ylabel('Pixels'); yyaxis left
title('Photon Flow --->')
mn = 50;
mx = 100;
xlim([mn mx])
j= 1;
for i = 0:mx-mn
    frame = getframe(gcf);
    im{j} = frame2im(frame);
    xlim([mn-i mx-i])
    j = j + 1;
end

filename = "testAnimated.gif"; % Specify the output file name
for i = 1:length(im)
    [A,map] = rgb2ind(im{i},4);
    if i == 1
        imwrite(A,map,filename,"gif","LoopCount",Inf,"DelayTime",.5);
    else
        imwrite(A,map,filename,"gif","WriteMode","append","DelayTime",.1);
    end
end