%Models a Poisson Process from first principles
mu = 5.2;                           %rate, events/time period
timePeriods = 20000;                %number of observations, for < 1% error
numEvents = mu*timePeriods;         %total number of events

events = rand(1,numEvents)*timePeriods;     %continuous time random events
counts = histcounts(events,0:timePeriods);  %counts in each time period

%% output
clf; histogram(counts);
hold on; histogram(poissrnd(mu,1,timePeriods))
xlabel('Number of Events per Time Period'); ylabel('Occurrences')
title(['Events/Period over ' num2str(timePeriods) ' Contiguous Periods'])
legend('First Principles','Matlab poissrnd')

disp(['Mean Count: ' num2str(mean (counts)) ' events/period, Std^2: ' ...
    num2str(std(counts)^2)])
events = sort(events);
disp(['Average Spacing between Events (time units): '...
    num2str(mean(events(2:end)-events(1:end-1)))])
disp(['Standard Dev of Event Occurrence (time Units): '...
    num2str(std(events(2:end)-events(1:end-1)))])
